# Copyright (C) 1991--2010 by INRIA.
#
# This file is part of Algolib.
#
# Algolib is free software: you can redistribute it and/or modify it
# under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# Algolib is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Algolib.  If not, see
# <http://www.gnu.org/licenses/>.

`multiseries/function`[arctanh, -1, "CoeffProc", 0, 0, 1]:=proc (n) local i1, loc, xxloc1; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:14`; xxloc1 := `multiseries/function`[arctanh,-1,"CoeffProc",0,0,0](n); loc[0] := 0; loc[1] := 1/2; for i1 from 2 to n do loc[i1] := -1/2*((-(2*i1-1)*op(i1,xxloc1)+4*i1*op(i1+1,xxloc1))/i1-(i1-1)*loc[i1-1])/i1 end do; [seq(loc[i1],i1 = 0 .. n)] end proc:
`multiseries/function`[arctanh, 1, "BasisVector", 0, 0, 1, "MultiSeries", 1]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:13`; SERIES(scale,`multiseries/function`[arctanh,1,"CoeffProc",0,0,0](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`arctanh/1/BasisVector/0/0/1/MultiSeries/1`(eval(scale['variable'],1))) end proc:
`multiseries/function`[arctanh, 1, "BasisVector", 0, 0, 0, "MultiSeries"]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:12`; [`multiseries/function`[arctanh,1,"BasisVector",0,0,0,"MultiSeries",0](args)] end proc:
`multiseries/function`[arctanh, 1, "BasisVector", 0, 0, 1, "MultiSeries", 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:12`; SERIES(scale,`multiseries/function`[arctanh,1,"CoeffProc",0,0,1](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`arctanh/1/BasisVector/0/0/1/MultiSeries/0`(eval(scale['variable'],1))) end proc:
`multiseries/function`[arctanh]:=proc (expr, scale, var, order) local tmp, re, im, lim, lim2, argseq, res; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:17`; if expr = 0 then return `multiseries/Convert2SERIES`(arctanh(0),scale,var,false) end if; lim := `multiseries/limit`(expr,scale,var); lim2 := lim; if lim = undefined then error "unable to compute series" elif has(lim,infinity) then lim := infinity end if; if lim = infinity then argseq := `multiseries/pow`(expr,-1,scale,var,order), scale, var, order else argseq := `multiseries/AddDoit`(expr,`multiseries/Convert2SERIES`(-lim,scale,var,false)), scale, var, order end if; if lim = -1 or Testzero(lim+1) then res := `multiseries/function`[arctanh,-1](argseq) elif lim = 0 then res := `multiseries/function`[arctanh,0](argseq) elif lim = 1 or Testzero(lim-1) then res := `multiseries/function`[arctanh,1](argseq) elif lim = infinity then res := `multiseries/function`[arctanh,infinity](argseq) else res := eval(`multiseries/function`[arctanh,_AnyFiniteOrdinaryPoint](argseq),_AnyFiniteOrdinaryPoint = lim) end if; if _Envnobranchcut <> true then if `multiseries/IsOnBranchCut`([1, infinity],expr,scale,var) then userinfo(2,MultiSeries,`branchcut:`,arctanh,[1, infinity]); if lim = infinity then im := `multiseries/sign`(Im(`multiseries/MulSeriesCst`(expr,1,algebraic))) else im := `multiseries/sign`(Im(`multiseries/MulSeriesCst`(`multiseries/AddDoit`(expr,-lim),1,algebraic))) end if; if im = 1 then _Envnobranchcut := true; userinfo(2,MultiSeries,`jump:`,arctanh,`multiseries/run`(I*Pi,scale,var,order)); res := `multiseries/run`(I*Pi+res,scale,var,order); _Envnobranchcut := false elif type(im,specfunc(anything,'signum')) or type(-im,specfunc(anything,signum)) then _Envnobranchcut := true; userinfo(2,MultiSeries,`jump:`,arctanh,`multiseries/run`(1/2*I*(im+1)*Pi,scale,var,order)); res := `multiseries/run`(1/2*I*(im+1)*Pi+res,scale,var,order); _Envnobranchcut := false end if 
	elif `multiseries/IsOnBranchCut`([-1, -infinity],expr,scale,var) then
		userinfo(2,MultiSeries,`branchcut:`,arctanh,[-1, -infinity]);
		if lim = infinity then im := `multiseries/sign`(Im(`multiseries/MulSeriesCst`(expr,-1,algebraic))) else im := `multiseries/sign`(Im(`multiseries/MulSeriesCst`(`multiseries/AddDoit`(expr,-lim),-1,algebraic))) end if; 
		if lim<>infinity then if im = 1 then userinfo(2,MultiSeries,`jump:`,arctanh,`multiseries/run`(-I*Pi,scale,var,order)); res := `multiseries/run`(-I*Pi+res,scale,var,order) elif type(im,specfunc(anything,'signum')) or type(-im,specfunc(anything,signum)) then userinfo(2,MultiSeries,`jump:`,arctanh,`multiseries/run`(-1/2*I*(im+1)*Pi,scale,var,order)); res := `multiseries/run`(-1/2*I*(im+1)*Pi+res,scale,var,order) end if         	else
       		    if im=-1 or im=0 then 
        		userinfo(2,MultiSeries,`jump:`,arctanh,`multiseries/run`(I*Pi,scale,var,order));
        		res := `multiseries/run`(I*Pi+res,scale,var,order)
        	    elif type(im,specfunc(anything,'signum')) or type(-im,specfunc(anything,signum)) then
        		userinfo(2,MultiSeries,`jump:`,arctanh,`multiseries/run`(1/2*I*(-im+1)*Pi,scale,var,order));
        		res := `multiseries/run`(1/2*I*(-im+1)*Pi+res,scale,var,order)
        	    fi
        	fi
end if end if; subsop(9 = arctanh(op(9,expr)),res) end proc:
`multiseries/function`[arctanh, 1, "BasisVector", 0, 0, 0]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:11`; [0, `multiseries/function`[arctanh,1,"CoeffProc",0,0,0](n)] end proc:
`multiseries/function`[arctanh, -1, "BasisVector", 0, 0, 0, "MultiSeries"]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:16`; [`multiseries/function`[arctanh,-1,"BasisVector",0,0,0,"MultiSeries",0](args)] end proc:
`multiseries/function`[arctanh, -1, "BasisVector", 0, 0, 1, "MultiSeries"]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:17`; [`multiseries/function`[arctanh,-1,"BasisVector",0,0,1,"MultiSeries",0](args), `multiseries/function`[arctanh,-1,"BasisVector",0,0,1,"MultiSeries",1](args)] end proc:
`multiseries/function`[arctanh, _AnyFiniteOrdinaryPoint]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:09`; `multiseries/compose`(SERIES(scale,map(normal,`multiseries/function`[arccoth,_AnyFiniteOrdinaryPoint,"CoeffProc"](order,arctanh(_AnyFiniteOrdinaryPoint),1/(1-_AnyFiniteOrdinaryPoint^2),_AnyFiniteOrdinaryPoint)),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),arctanh(_AnyFiniteOrdinaryPoint+eval(scale['variable'],1))),expr,scale,var,order) end proc:
`multiseries/function`[arctanh, -1, "CoeffProc", 0, 0, 0]:=proc (n) local i1, loc; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:14`; loc[0] := 1; loc[1] := 0; for i1 from 2 to n do loc[i1] := 1/2*(i1-1)*loc[i1-1]/i1 end do; [seq(loc[i1],i1 = 0 .. n)] end proc:
`multiseries/function`[arctanh, -1, "BasisVector", 0, 0, 1, "MultiSeries", 1]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:16`; SERIES(scale,`multiseries/function`[arctanh,-1,"CoeffProc",0,0,0](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`arctanh/-1/BasisVector/0/0/1/MultiSeries/1`(eval(scale['variable'],1))) end proc:
`multiseries/function`[arctanh, 1, "CoeffProc", 0, 0, 1]:=proc (n) local i1, loc, xxloc1; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:11`; xxloc1 := `multiseries/function`[arctanh,1,"CoeffProc",0,0,0](n); loc[0] := 0; loc[1] := 1/2; for i1 from 2 to n do loc[i1] := 1/2*((-(1-2*i1)*op(i1,xxloc1)-4*i1*op(i1+1,xxloc1))/i1-(1-i1)*loc[i1-1])/i1 end do; [seq(loc[i1],i1 = 0 .. n)] end proc:
`multiseries/function`[arctanh, 1, "BasisVector", 0, 0, 1, "MultiSeries"]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:13`; [`multiseries/function`[arctanh,1,"BasisVector",0,0,1,"MultiSeries",0](args), `multiseries/function`[arctanh,1,"BasisVector",0,0,1,"MultiSeries",1](args)] end proc:
`multiseries/function`[arctanh, infinity]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:09`; `multiseries/compose`(SERIES(scale,`multiseries/function`[arccoth,infinity,"CoeffProc"](order,-1/2*I*Pi,1),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),arctanh(1/eval(scale['variable'],1))),expr,scale,var,order) end proc:
`multiseries/function`[arctanh, 1, "CoeffProc", 0, 0, 0]:=proc (n) local i1, loc; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:10`; loc[0] := 1; loc[1] := 0; for i1 from 2 to n do loc[i1] := -1/2*(1-i1)*loc[i1-1]/i1 end do; [seq(loc[i1],i1 = 0 .. n)] end proc:
`multiseries/function`[arctanh, -1, "BasisVector", 0, 0, 1, "MultiSeries", 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:16`; SERIES(scale,`multiseries/function`[arctanh,-1,"CoeffProc",0,0,1](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`arctanh/-1/BasisVector/0/0/1/MultiSeries/0`(eval(scale['variable'],1))) end proc:
`multiseries/function`[arctanh, -1]:=proc (expr, scale, var, order) local loc1, loc2, loc3, res, res1, res2; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:17`; ASSERT(`multiseries/limit`(expr,scale,var) = 0 or Testzero(`multiseries/limit`(expr,scale,var))); loc3 := `multiseries/MulSeriesCst`(expr,1,algebraic); loc1 := `multiseries/function`[arctanh,-1,"BasisVector",0,0,0,"MultiSeries"](loc3,scale,var,order); loc2 := -1/2*ln(2); res1 := `multiseries/function`["Helper","RegularBasisVector"](loc1,[loc3, scale, var, order],0,loc2,-1); loc1 := `multiseries/function`[arctanh,-1,"BasisVector",0,0,1,"MultiSeries"](loc3,scale,var,order); loc2 := 1/2; res2 := `multiseries/function`["Helper","RegularBasisVector"](loc1,[loc3, scale, var, order],0,loc2,-1); res := `multiseries/add`([res1, res2]); subsop(9 = arctanh(op(9,expr)),res) end proc:
`multiseries/function`[arctanh, 1, "BasisVector", 0, 0, 0, "MultiSeries", 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:12`; SERIES(scale,`multiseries/function`[arctanh,1,"CoeffProc",0,0,0](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`arctanh/1/BasisVector/0/0/0/MultiSeries/0`(eval(scale['variable'],1))) end proc:
`multiseries/function`[arctanh, -1, "BasisVector", 0, 0, 0, "MultiSeries", 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:15`; SERIES(scale,`multiseries/function`[arctanh,-1,"CoeffProc",0,0,0](order),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),`arctanh/-1/BasisVector/0/0/0/MultiSeries/0`(eval(scale['variable'],1))) end proc:
`multiseries/function`[arctanh, 0]:=proc (expr, scale, var, order) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:09`; `multiseries/compose`(SERIES(scale,`multiseries/function`[arccoth,_AnyFiniteOrdinaryPoint,"CoeffProc"](order,0,1,0),1,algebraic,[`$`(0 .. order)],order+1,integer,eval(scale['variable'],1),arctanh(eval(scale['variable'],1))),expr,scale,var,order) end proc:
`multiseries/function`[arctanh, -1, "BasisVector", 0, 0, 0]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:15`; [0, `multiseries/function`[arctanh,-1,"CoeffProc",0,0,0](n)] end proc:
`multiseries/function`[arctanh, -1, "BasisVector", 0, 0, 1]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:15`; [0, `multiseries/function`[arctanh,-1,"CoeffProc",0,0,1](n), `multiseries/function`[arctanh,-1,"CoeffProc",0,0,0](n)] end proc:
`multiseries/function`[arctanh, 1]:=proc (expr, scale, var, order) local loc1, loc2, loc3, res, res1, res2; option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:13`; ASSERT(`multiseries/limit`(expr,scale,var) = 0 or Testzero(`multiseries/limit`(expr,scale,var))); loc3 := `multiseries/MulSeriesCst`(expr,-1,algebraic); loc1 := `multiseries/function`[arctanh,1,"BasisVector",0,0,0,"MultiSeries"](loc3,scale,var,order); loc2 := 1/2*ln(2); res1 := `multiseries/function`["Helper","RegularBasisVector"](loc1,[loc3, scale, var, order],0,loc2,1); loc1 := `multiseries/function`[arctanh,1,"BasisVector",0,0,1,"MultiSeries"](loc3,scale,var,order); loc2 := -1/2; res2 := `multiseries/function`["Helper","RegularBasisVector"](loc1,[loc3, scale, var, order],0,loc2,1); res := `multiseries/add`([res1, res2]); subsop(9 = arctanh(op(9,expr)),res) end proc:
`multiseries/function`[arctanh, 1, "BasisVector", 0, 0, 1]:=proc (n) option `Copyright (c) 2004 by Ludovic Meunier and the Algorithms Project, INRIA. All rights reserved. - generated 10/26/2004 @ 23:24:11`; [0, `multiseries/function`[arctanh,1,"CoeffProc",0,0,1](n), `multiseries/function`[arctanh,1,"CoeffProc",0,0,0](n)] end proc:
